#include "FAtoLRGConverter.h"

using namespace std;
using namespace automaton;
using namespace grammar;

namespace conversions
{

FAtoLRGConverter::FAtoLRGConverter( const FSM & automaton ) : AbstractFAtoLRGConverter( automaton )
{

}

FAtoLRGConverter::~FAtoLRGConverter( void )
{

}

LeftRegularGrammar FAtoLRGConverter::convert( void )
{
    for( const auto & symbol : m_fsm.getInputAlphabet( ) )
        m_grammar.addTerminalSymbol( symbol );

    StateNonterminalMap symbolMap( m_fsm, m_grammar );

    // step 2 - create set of P in G
    for( const auto & transition : m_fsm.getTransitions( ) )
    {
        // 2a
        list<Symbol> leftSide, rightSide;
        leftSide.push_back( symbolMap.getNonTerminal( transition.getTo( ) ) );
        rightSide.push_back( symbolMap.getNonTerminal( transition.getFrom( ) ) );
        rightSide.push_back( transition.getInput( ) );
        m_grammar.addRule( Rule( leftSide, rightSide ) );

        // 2b
        if( isInSet( transition.getFrom( ), m_fsm.getInitialStates( ) ) )
        {
            list<Symbol> leftSide, rightSide;
            leftSide.push_back( symbolMap.getNonTerminal( transition.getTo( ) ) );
            rightSide.push_back( transition.getInput( ) );
            m_grammar.addRule( Rule( leftSide, rightSide ) );
        }
    }

    // step 3
    Symbol newStart = m_grammar.createUniqueNonTerminalSymbol( "S", false );
    m_grammar.setStartSymbol( newStart );

    //
    if( isInSet( * m_fsm.getInitialStates( ).begin( ), m_fsm.getFinalStates( ) ) )
    {
        list<Symbol> leftSide = { newStart }, rightSide;
        m_grammar.addRule( Rule( leftSide, rightSide ) );
    }

    // pro vsecky neterminaly, ktere vznikly z finalnich stavu:
        // kopiruj jejich prave strany k newStart
        // pokud nejsou nikde vpravo, smaz je

    for( const auto & rule : m_grammar.getRules( ) )
    {
        const Symbol & leftSide = * rule.getLeftSide( ).begin( );

        if( isInSet( State( leftSide.getSymbol( ) ), m_fsm.getFinalStates( ) ) )
        {
            list<Symbol> leftSide = { newStart }, rightSide( rule.getRightSide( ) );
            m_grammar.addRule( Rule( leftSide, rightSide ) );
        }

        // jetenhle krok nutny,???
        // if( leftSide != m_grammar.getStartSymbol( ) && ! m_grammar.isNonTerminalOnRightSideOfAnyRule( leftSide ) )
        //    m_grammar.removeRule( rule );
    }

    return m_grammar;
}
} /* namespace conversions */
