//============================================================================
// Name        : aconvert.dot.cpp
// Author      : Martin Zak
//============================================================================

#include <iostream>
#include "automaton/AutomatonParser.h"
#include "automaton/UnknownAutomaton.h"
#include "AutomatonFactory.h"
#include "AlibException.h"
#include "sax/SaxInterface.h"

#include "DotConverter.h"

#define VERSION "0.0.1"
#define USAGE "aconvert.dot [inputfile]"

using namespace std;
using namespace automaton;
using namespace sax;
using namespace alib;

int main(int argc, char** argv) {
	list<Token> tokens;

	if (argc > 1) {
		if (string(argv[1]) == "-v") {
			cout << USAGE;
			cout << endl;
			return EXIT_SUCCESS;
		}
		SaxInterface::parseFile(argv[1], tokens);

	} else {
		string input(istreambuf_iterator<char>(cin),
				(istreambuf_iterator<char>()));
		SaxInterface::parseMemory(input, tokens);
	}

	UnknownAutomaton unknownAutomaton = AutomatonParser::parse(tokens);
	Automaton* automaton = AutomatonFactory::buildAutomaton(unknownAutomaton);
	DotConverter::convert(*automaton, cout);
}
