#ifndef RHDPDADETERMINZER_H_
#define RHDPDADETERMINZER_H_

#include <string>
#include <set>
#include <map>
#include <vector>

#include "automaton/PDA/PDA.h"
#include "automaton/Transition.h"
#include "automaton/exception/AutomatonException.h"
#include "alphabet/Symbol.h"
#include "DeterminizationUtils.h"
#include "RHDPDADeterminizationUtils.h"
#include "RHDPDADeterminizationStructs.h"

using namespace std;
using namespace automaton;
using namespace alphabet;

namespace determinization {

class RHDPDADeterminizer {
protected:
    static void divideTransitions(const set<TransitionPDA>& transitions, set<TransitionPDA>& internalTransitions,
        set<TransitionPDA>& pushTransitions, set<TransitionPDA>& popTransitions);

public:
    static PDA determinize(PDA& automaton);
};

} /* namespace determinization */
#endif /* RHDPDADETERMINZER_H_ */