/*
 * AutomatonDiff.h
 *
 *  Created on: Apr 1, 2013
 *      Author: honza
 */

#ifndef AUTOMATON_DIFF_H_
#define AUTOMATON_DIFF_H_

#include <ostream>

#include <automaton/UnknownAutomaton.h>
#include <map>
#include <utility>

class AutomatonDiff {
	static bool testDiff(const automaton::UnknownAutomaton& a, const automaton::UnknownAutomaton& b);
	static void printDiff(const automaton::UnknownAutomaton& a, const automaton::UnknownAutomaton& b);

	template <class T> static void setDiff(const std::set<T> a, const std::set<T> b);
	template <class T> static void listDiff(const std::list<T> a, const std::list<T> b);
public:
	static int diff(const automaton::UnknownAutomaton& a, const automaton::UnknownAutomaton& b);
};

#endif /* AUTOMATON_DIFF_H_ */
