/*
 * TransitionFSM.h
 *
 *  Created on: Mar 26, 2013
 *      Author: martin
 */

#ifndef TRANSITIONFSM_H_
#define TRANSITIONFSM_H_

#include "../Transition.h"
#include <ostream>

namespace automaton {

/**
 * Represents transition rule for FSM.
 */
class TransitionFSM : public Transition {
public:
	/**
	 * Creates new transition with given parameters.
	 * @param from from state
	 * @param input input symbol
	 * @param to to state
	 */
	TransitionFSM(const State& from,const Symbol& input,const State& to);

	bool operator <(const TransitionFSM& other) const;
	bool operator ==(const TransitionFSM& other) const;
	bool operator !=(const TransitionFSM& other) const;

	std::ostream& operator>>(std::ostream& out) const;
};

} /* namespace automaton */
#endif /* TRANSITIONFSM_H_ */
