/*
 * StateFSM.h
 *
 *  Created on: Mar 26, 2013
 *      Author: martin
 */

#ifndef STATEFSM_H_
#define STATEFSM_H_

#include <string>
#include <ostream>

namespace automaton {

/**
 * Class representing state in an automaton.
 */
class State {
private:
	std::string name;
public:
	State(const std::string& name);
	const std::string& getName() const;

	bool operator < (const State& other) const;
	bool operator == (const State& other) const;
	bool operator != (const State& other) const;

	friend std::ostream& operator<<(std::ostream&, const State&);
};

} /* namespace automaton */
#endif /* STATEFSM_H_ */
