/*
 * RegExpEmpty.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: honza
 */

#include "RegExpEmpty.h"

namespace regexp {

RegExpEmpty::RegExpEmpty() {
}

RegExpElement* RegExpEmpty::clone() const {
	return new RegExpEmpty();
}

bool RegExpEmpty::operator<(const RegExpElement& other) const {
	return other > *this;
}

bool RegExpEmpty::operator==(const RegExpElement& other) const {
	return other == *this;
}

bool RegExpEmpty::operator>(const RegExpElement& other) const {
	return other < *this;
}


bool RegExpEmpty::operator<(const Concatenation&) const {
	return true;
}

bool RegExpEmpty::operator<(const Alternation&) const {
	return true;
}

bool RegExpEmpty::operator<(const Iteration&) const {
	return true;
}

bool RegExpEmpty::operator<(const RegExpSymbol&) const {
	return true;
}

bool RegExpEmpty::operator<(const RegExpEpsilon&) const {
	return true;
}

bool RegExpEmpty::operator==(const RegExpEmpty&) const {
	return true;
}

bool RegExpEmpty::containsEmptyString() const {
	return false;
}

} /* namespace regexp */

