/*
 * RegExpEmpty.h
 *
 *  Created on: Jan 30, 2014
 *      Author: honza
 */

#ifndef REGEXPEMPTY_H_
#define REGEXPEMPTY_H_

#include "RegExpElement.h"

namespace regexp {

using namespace std;

/**
 * Represents empty regular expression in the regular expression.
 */
class RegExpEmpty: public RegExpElement {
public:
	RegExpEmpty();

	/**
	 * @copydoc RegExpElement::clone() const
	 */
	RegExpElement* clone() const;

	virtual bool operator<(const RegExpElement&) const;
	virtual bool operator==(const RegExpElement&) const;
	virtual bool operator>(const RegExpElement&) const;

	virtual bool operator<(const Concatenation&) const;
	virtual bool operator<(const Alternation&) const;
	virtual bool operator<(const Iteration&) const;
	virtual bool operator<(const RegExpSymbol&) const;
	virtual bool operator<(const RegExpEpsilon&) const;
	virtual bool operator==(const RegExpEmpty&) const;

	/**
	 * @copydoc RegExpElement::containsEmptyString() const
	 */
	bool containsEmptyString() const;
};

} /* namespace regexp */
#endif /* REGEXPEMPTY_H_ */
