#include <iostream>
#include "regexp/RegExpParser.h"
#include "AlibException.h"
#include "sax/SaxInterface.h"

#include "RegExpOptimize.h"


using namespace std;
using namespace regexp;
using namespace sax;
using namespace alib;

int main(int argc, char** argv) {
	list<Token> tokens;

	if (argc > 1) {
		SaxInterface::parseFile(argv[1], tokens);
	} else {
		string input(istreambuf_iterator<char>(cin),
				(istreambuf_iterator<char>()));
		SaxInterface::parseMemory(input, tokens);
	}

	RegExp regexp = RegExpParser::parse(tokens);
	RegExpOptimize opt;
	regexp = opt.optimize(regexp);
	regexp.toXML(cout);

	return 0;
}
