#ifndef REGEXPALPHABET_H_
#define REGEXPALPHABET_H_

#include <regexp/RegExp.h>
#include <regexp/RegExpElement.h>
#include <regexp/Alternation.h>
#include <regexp/Concatenation.h>
#include <regexp/Iteration.h>
#include <regexp/RegExpSymbol.h>
#include <regexp/RegExpEmpty.h>
#include <regexp/RegExpEpsilon.h>

#include <AlibException.h>

#include <list>
#include <set>

class RegExpAlphabet
{
public:
    static std::list<const regexp::RegExpSymbol*> getSymbolsListInOrder( const regexp::RegExp & re );
    static std::set<regexp::RegExpSymbol> getSymbols( const regexp::RegExp & re );

private:
    static void searchSymbols( const regexp::RegExpElement * element, std::list<const regexp::RegExpSymbol*> & alphabet );
};

#endif /* REGEXPALPHABET_H_ */
